require("gunManager")
do
  local _parent_0 = Entity
  local _base_0 = {
    update = function(self, dt)
      self:collect()
      return _parent_0.update(self, self)
    end,
    draw = function(self)
      love.graphics.setColor(0, 255, 0)
      love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
      love.graphics.setColor(0, 0, 0)
      love.graphics.print(self.quantity .. " " .. self.type, self.x, self.y)
      return _parent_0.draw(self, self)
    end,
    collect = function(self)
      if mad.col:checkCol(self, self.x, self.y, col.player) ~= 0 then
        if PlayerManager.inventory[1] == nil then
          table.insert(PlayerManager.inventory, InvAmmo(self.quantity, self.type))
        else
          for k, v in pairs(PlayerManager.inventory) do
            if v.type == self.type then
              print("Added " .. self.quantity .. " " .. self.type .. " to the stack of " .. v.quantity .. " " .. v.type)
              v.quantity = v.quantity + self.quantity
              break
            elseif k == #PlayerManager.inventory and v.type ~= self.type then
              table.insert(PlayerManager.inventory, InvAmmo(self.quantity, self.type))
              break
            end
          end
        end
        return mad.object:remove(self)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, x, y)
      self.x, self.y = x, y
      self.type = gunManager.ammoTypes[math.random(1, #gunManager.ammoTypes)]
      self.quantity = math.random(2, 6)
      return _parent_0.__init(self, self, 32, 32, "ammo_drop", col.drop)
    end,
    __base = _base_0,
    __name = "AmmoDrop",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  AmmoDrop = _class_0
end
