require("gunManager")
do
  local _parent_0 = Entity
  local _base_0 = {
    update = function(self, dt)
      self:collect()
      return _parent_0.update(self, self)
    end,
    draw = function(self)
      love.graphics.setColor(255, 0, 0)
      love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
      return _parent_0.draw(self, self)
    end,
    collect = function(self)
      if mad.col:checkCol(self, self.x, self.y, col.player) ~= 0 then
        table.insert(DungeonManager.rewards, self.drop)
        return mad.object:remove(self)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, x, y)
      self.x, self.y = x, y
      self.type = gunManager.types[math.random(1, 3)]
      if self.type == "grip" then
        self.drop = gunManager.grip[math.random(1, 2)]
      elseif self.type == "base" then
        self.drop = gunManager.base[math.random(1, 2)]
      elseif self.type == "barrel" then
        self.drop = gunManager.barrel[math.random(1, 2)]
      end
      return _parent_0.__init(self, self, 32, 32, "gun_part_drop", col.drop)
    end,
    __base = _base_0,
    __name = "GunPartDrop",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GunPartDrop = _class_0
end
