do
  local _parent_0 = Entity
  local _base_0 = {
    update = function(self, dt)
      self:move()
      self:shoot()
      self:knockback()
      return _parent_0.update(self, self)
    end,
    draw = function(self)
      love.graphics.setColor(0, 0, 0)
      love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
      return _parent_0.draw(self, self)
    end,
    keypressed = function(self, key)
      self:dodge(key)
      if key == "i" then
        for k, v in pairs(PlayerManager.inventory) do
          print(k, v, v.quantity, v.type)
        end
      end
    end,
    destroy = function(self) end,
    move = function(self)
      if mad.input:key("left") then
        self.x = self.x - self.spd
      end
      if mad.input:key("right") then
        self.x = self.x + self.spd
      end
      if mad.input:key("up") then
        self.y = self.y - self.spd
      end
      if mad.input:key("down") then
        self.y = self.y + self.spd
      end
    end,
    dodge = function(self, key)
      if key == keys.dodge then
        return print("dodged")
      end
    end,
    shoot = function(self)
      if self.fire_timer > 0 then
        self.fire_timer = self.fire_timer - 1
      else
        self.can_shoot = true
      end
      if mad.input:key(keys.shoot) then
        if self.can_shoot then
          mad.object:create(Bullet(self.x + self.w / 2 - 16, self.y))
          self.fire_timer = self.firerate * 60
          self.can_shoot = false
          self.knocking = true
        end
      end
    end,
    knockback = function(self)
      if self.knocking then
        self.y = self.y + self.kickback
        self.kickback_timer = self.kickback_timer - 1
      end
      if self.kickback_timer <= 0 then
        self.knocking = false
        self.kickback_timer = 5
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, x, y)
      self.x, self.y = x, y
      self.spd = 4.5
      self.firerate = PlayerManager.gun_base.fire_rate
      self.fire_timer = self.firerate * 60
      self.can_shoot = true
      self.kickback = PlayerManager.gun_grip.kickback
      self.kickback_timer = 6
      self.knocking = false
      self.pattern = PlayerManager.gun_barrel.pattern
      return _parent_0.__init(self, self, 64, 64, "player", col.player)
    end,
    __base = _base_0,
    __name = "Player",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Player = _class_0
end
