require("lib.mad.madlib")
require.tree("ent")
require("dungeonManager")
require("playerManager")
room_reg = {
  test = {
    name = "test",
    event = function(self)
      mad.object:create(PauseMenu(0, 0))
      mad.object:create(Player(32, 32))
      mad.object:create(AmmoDrop(400, 64))
      mad.object:create(AmmoDrop(200, 64))
      mad.object:create(AmmoDrop(500, 64))
      mad.object:create(GunPartDrop(32, 300))
      mad.object:create(GunPartDrop(100, 300))
      return mad.object:create(GunPartDrop(300, 300))
    end
  },
  main_menu = {
    name = "main_menu",
    event = function(self)
      mad.object:create(Background(0, 0))
      return mad.object:create(Menu(0, 0))
    end
  },
  town_plaza = {
    name = "town_plaza",
    event = function(self)
      return mad.object:create(Player(32, 32))
    end
  },
  town_garden = {
    name = "town_garden",
    event = function(self) end
  },
  town_player_home = {
    name = "town_player_home",
    event = function(self) end
  },
  town_food_bar = {
    name = "town_food_bar",
    event = function(self) end
  },
  town_launchpad = {
    name = "town_launchpad",
    event = function(self) end
  },
  plains_dungeon = {
    name = "plains_dungeon",
    event = function(self)
      DungeonManager:refresh("plains_dungeon")
      if DungeonManager.current_room == 1 then
        return print("entrance")
      elseif DungeonManager.current_room == DungeonManager.boss_room then
        return print("boss!!!!")
      elseif DungeonManager.current_room == DungeonManager.boss_room + 1 then
        return print("exit room")
      else
        return print("new screen")
      end
    end
  },
  airship_dungeon = {
    name = "airship_dungeon",
    event = function(self)
      DungeonManager:refresh("airship_dungeon")
      if DungeonManager.current_room == 1 then
        return print("entrance")
      elseif DungeonManager.current_room == DungeonManager.boss_room then
        return print("boss!!!!")
      elseif DungeonManager.current_room == DungeonManager.boss_room + 1 then
        return print("exit room")
      else
        return print("new screen")
      end
    end
  },
  dungeon_rewards = {
    name = "dungeon_rewards",
    event = function(self)
      return mad.object:create(DungeonRewardsMenu(0, 0))
    end
  }
}
love.load = function()
  love.graphics.setDefaultFilter('nearest', 'nearest')
  mad:init()
  return mad.room:change("main_menu")
end
love.update = function(dt)
  return mad:update(dt)
end
love.draw = function()
  return mad:draw(camera)
end
love.keypressed = function(key)
  if key == "q" then
    mad.room:change("dungeon_rewards")
  end
  return mad:keypressed(key)
end
love.timer.sleep = function() end
